<app-page-title [heading]="heading" [subheading]="subheading" [icon]="icon">
  <button (click)="getDataSource()" class="btn btn-default">
    <i class="fas fa-sync-alt" [ngClass]="{'fa-spin': !dataGrid}"></i>
  </button>
  <button (click)="newRow(modalHelp, 'sm')" class="btn btn-primary ml-1">
    <i class="fa fa-plus mr-2"></i>Nuevo
  </button>
  <!-- <button (click)="printPDF()" class="btn btn-danger ml-1" [disabled]="!dataGrid.data">
    <i class="far fa-file-pdf mr-2"></i>PDF
  </button> -->
</app-page-title>


<div class="card">
  <div class="card-body">

    <ng-container *ngIf="!loading">

      <kendo-grid id="kGrid" [kendoGridBinding]="dataGrid" [pageSize]="pageSize"
        [pageable]="{buttonCount: 5, pageSizes: [10, 25, 50]}" [filter]="filter" filterable="menu" [selectable]="true"
        [navigable]="true" [reorderable]="true" [resizable]="true" [sortable]="true"
        (edit)="editRow($event, modalHelp, 'sm')"
        (remove)="deleteRow($event)" style="height: 69vh;">
        <ng-container *ngFor="let item of gridFields">
          <kendo-grid-column [field]="item.dataKey" [title]="item.title" [width]="item.width"
            [filterable]="item.filtro"></kendo-grid-column>
        </ng-container>
        <kendo-grid-column field="duso" title="Uso" width="120">
          <ng-template kendoGridCellTemplate let-dataItem>
            <span *ngIf="dataItem.duso">Si</span>
            <span *ngIf="!dataItem.duso">No Cuadra!!!</span>
          </ng-template>
        </kendo-grid-column>
        <kendo-grid-column field="Inactivo" title="Inactivo" width="120">
          <ng-template kendoGridCellTemplate let-dataItem>
            <span *ngIf="dataItem.Inactivo">Si</span>
            <span *ngIf="!dataItem.Inactivo">No</span>
          </ng-template>
        </kendo-grid-column>
        <kendo-grid-column field="Detalle" title="Desglose" widht="" filterable="">
          <ng-template kendoGridCellTemplate let-dataItem>
            <button (click)="open(dataItem, modalHelp2, 'lg')" class="btn btn-light">
              <i class="fa fa-list mr-2"></i>Ver Desglose
            </button>
          </ng-template>
        </kendo-grid-column>
        <kendo-grid-command-column title="Acciones" width="190">
          <ng-template kendoGridCellTemplate>
            <button kendoGridEditCommand [primary]="true">Editar</button>
            <button kendoGridRemoveCommand>Eliminar</button>
          </ng-template>
        </kendo-grid-command-column>
      </kendo-grid>

    </ng-container>

    <app-loading *ngIf="loading">Buscando resultados...</app-loading>

  </div>
</div>

<ng-template #modalHelp2 let-modal let-c="close">
  <div class="modal-header">
    <div class="modal-title">Detalle Desglose Tarifa {{ idDesglose }}</div>
    <button class="close" aria-label="Close" (click)="modal.dismiss('Cross click'); validarDesglose(myFormGroup.value);">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body" *ngIf="!loading">
    <div class="row d-flex justify-content-end">
      <button class="btn btn-primary mr-1" (click)="nuevoDetalle()">
        <i class="fas fa-plus mr-2"></i>Nuevo
      </button>
      <button class='btn btn-success mr-1' [disabled]="ngFormDetalle.invalid" (click)="guardarDetalle()">
        <i class="fas fa-save mr-2"></i>Guardar
      </button>
    </div>

    <div class="divider"></div>

    <form [formGroup]="ngFormDetalle">
      <div class="row">
        <div class="form-group col-12 col-sm-12 col-md-6 col-lg-6 col-xl-6">
          <label>Código</label>
          <kendo-combobox [data]="tblCodDesglose" formControlName="dcodigo" [textField]="'cdesc'"
            [valueField]="'Codigo'" [valuePrimitive]="true" class="w-100" [readonly]="flagEditDetalle">
          </kendo-combobox>
        </div>
        <ng-container *ngFor="let i of arrTariCols; let index = index;">
          <div class="form-group col-6 col-sm-6 col-md-3 col-lg-3 col-xl-3">
            <label>{{ i }}</label>
            <input type="number" min="0" max="999" formControlName="dta{{ index + 1 }}" class="form-control">
          </div>
          <div class="form-group col-6 col-sm-6 col-md-3 col-lg-3 col-xl-3">
            <label class="w-100">Porc.</label>
            <kendo-switch formControlName="dpa{{ index + 1 }}" [onLabel]="'Si'" [offLabel]="'No'"></kendo-switch>
          </div>
        </ng-container>

        <div class="form-group col-6 col-sm-6 col-md-3 col-lg-3 col-xl-3">
          <label>Adicional</label>
          <input type="number" formControlName="dta11" class="form-control" min="0" max="999">
        </div>
        <div class="form-group col-6 col-sm-6 col-md-3 col-lg-3 col-xl-3">
          <label class="w-100">Porc.</label>
          <kendo-switch formControlName="dpa11" [onLabel]="'Si'" [offLabel]="'No'"></kendo-switch>
        </div>
        <div class="form-group col-6 col-sm-6 col-md-3 col-lg-3 col-xl-3">
          <label for="">Junior</label>
          <input type="number" formControlName="dtj11" class="form-control" [readOnly]="!ttInfocia.cjunior"
                 min="0" max="999">
        </div>
        <div class="form-group col-6 col-sm-6 col-md-3 col-lg-3 col-xl-3">
          <label class="w-100">Porc.</label>
          <kendo-switch formControlName="dpj11" [onLabel]="'Si'" [offLabel]="'No'" [readonly]="!ttInfocia.cjunior">
          </kendo-switch>
        </div>
        <div class="form-group col-6 col-sm-6 col-md-3 col-lg-3 col-xl-3">
          <label>Menor</label>
          <input type="number" formControlName="dtm11" class="form-control" [readOnly]="!ttInfocia.cmenor"
                 min="0" max="999">
        </div>
        <div class="form-group col-6 col-sm-6 col-md-3 col-lg-3 col-xl-3">
          <label class="w-100">Porc.</label>
          <kendo-switch formControlName="dpm11" [onLabel]="'Si'" [offLabel]="'No'" [readonly]="!ttInfocia.cmenor">
          </kendo-switch>
        </div>
      </div>
    </form>

    <kendo-grid [data]="tblDetalleDesg" [navigable]="true" [selectable]="true" (selectionChange)="changeDesglose($event)"
      style="height: 31vh;">
      <kendo-grid-column field="dcodigo" title="Código" width="110"></kendo-grid-column>
      <ng-container *ngFor="let i of arrTariCols; let index = index;">
        <kendo-grid-column field="dta{{ index + 1 }}" title="{{ i }}" width="100" class="text-right">
          <ng-template kendoGridCellTemplate let-dataItem let-column="column">
            {{ dataItem[column.field] | kendoNumber:'##.00' }}
          </ng-template>
        </kendo-grid-column>
        <kendo-grid-column field="dpa{{ index + 1 }}" title="Porc." width="70" class="text-right">
          <ng-template kendoGridCellTemplate let-dataItem let-column="column">
            <span *ngIf="dataItem[column.field]">Si</span>
            <span *ngIf="!dataItem[column.field]">No</span>
          </ng-template>
        </kendo-grid-column>
      </ng-container>

      <kendo-grid-column field="dta11" title="Adi." width="100" class="text-right">
        <ng-template kendoGridCellTemplate let-dataItem let-column="column">
          {{ dataItem[column.field] | kendoNumber:'##.00' }}
        </ng-template>
      </kendo-grid-column>
      <kendo-grid-column field="dpa11" title="Porc." width="70" class="text-right">
        <ng-template kendoGridCellTemplate let-dataItem>
          <span *ngIf="dataItem.dpa11">Si</span>
          <span *ngIf="!dataItem.dpa11">No</span>
        </ng-template>
      </kendo-grid-column>

      <kendo-grid-column field="dtj11" title="Jrs." width="100" class="text-right">
        <ng-template kendoGridCellTemplate let-dataItem let-column="column">
          {{ dataItem[column.field] | kendoNumber:'##.00' }}
        </ng-template>
      </kendo-grid-column>
      <kendo-grid-column field="dpj11" title="Porc." width="70" class="text-right">
        <ng-template kendoGridCellTemplate let-dataItem>
          <span *ngIf="dataItem.dpj11">Si</span>
          <span *ngIf="!dataItem.dpj11">No</span>
        </ng-template>
      </kendo-grid-column>

      <kendo-grid-column field="dtm11" title="Menor" width="100" class="text-right">
        <ng-template kendoGridCellTemplate let-dataItem let-column="column">
          {{ dataItem[column.field] | kendoNumber:'##.00' }}
        </ng-template>
      </kendo-grid-column>
      <kendo-grid-column field="dpm11" title="Porc." width="70" class="text-right">
        <ng-template kendoGridCellTemplate let-dataItem>
          <span *ngIf="dataItem.dpm11">Si</span>
          <span *ngIf="!dataItem.dpm11">No</span>
        </ng-template>
      </kendo-grid-column>

      <kendo-grid-command-column title="Acciones" width="220">
        <ng-template kendoGridCellTemplate let-dataItem>
          <button class="btn btn-info mr-1" (click)="editarDetalle(dataItem)">
            <i class="fas fa-edit mr-2"></i>Editar
          </button>
          <button class="btn btn-danger mr-1" (click)="crudServiceDetalle(dataItem, 'delete')">
            <i class="fas fa-trash mr-2"></i>Eliminar
          </button>
        </ng-template>
      </kendo-grid-command-column>
    </kendo-grid>

  </div>
  <app-loading *ngIf="loading"></app-loading>
  <div class="modal-footer">
    <button class="btn btn-secondary" (click)="c('Close click'); validarDesglose(myFormGroup.value);">Cerrar</button>
  </div>

</ng-template>

<ng-template #modalHelp let-modal let-c="close">
  <div class="modal-header">
    <div class="modal-title">Desglose de Tarifas</div>
    <button class="close" aria-label="Close" (click)="modal.dismiss()">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">

    <form [formGroup]="myFormGroup">
      <div class="row d-flex justify-content-between">
        <div class="form-group col-12">
          <label>Desglose</label>
          <input type="text" class="form-control" formControlName="Detalle" [readOnly]="flagEdit"
                 maxlength="6" pattern="[a-zA-Z0-9]*"/>
        </div>
        <div class="form-group col-12">
          <label>Descripción</label>
          <input type="text" class="form-control" formControlName="ddesc"
                 maxlength="30" pattern="[a-zA-Z0-9 ]*">
        </div>
        <div class="form-group col-6">
          <label class="w-100">Inactivo</label>
          <kendo-switch formControlName="Inactivo" [onLabel]="'Si'" [offLabel]="'No'"></kendo-switch>
        </div>
        <div class="form-group col-6">
          <label class="w-100">Uso</label>
          <kendo-switch formControlName="duso" [onLabel]="'Si'" [offLabel]="'No'" [attr.disabled]="true"></kendo-switch>
        </div>
      </div>
    </form>
  </div>
  <div class="modal-footer">
    <button class="btn btn-success mr-1" [disabled]="myFormGroup.invalid" (click)="guardarForm()">
      <i class="fas fa-save mr-2"></i>Guardar
    </button>
    <button class="btn btn-secondary" (click)="c()">Cerrar</button>
  </div>
</ng-template>
